unit EditMap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,TypConst, StdCtrls, Grids, ImgList, ComCtrls, ToolWin, ExtCtrls,
  AppEvnts;

type
  TForm1 = class(TForm)
    DrawGrid1: TDrawGrid;
    Edit1: TEdit;
    ImageList1: TImageList;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    Panel1: TPanel;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    Label1: TLabel;
    ToolButton4: TToolButton;
    Button1: TButton;
    ApplicationEvents1: TApplicationEvents;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ToolButton1Click(Sender: TObject);
    procedure ApplicationEvents1ShortCut(var Msg: TWMKey;
      var Handled: Boolean);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    Map,Byf:Karta;
    NomLev:word;
    ActBar:Integer;

    x,y         :byte;
    Napr        :byte;
    procedure ResetPole;
    Procedure BarPole(ACol, ARow:integer;typ:byte);
    procedure BLeft;
    procedure BRight;
    procedure BVerx;
    procedure BNuz;
    Function Stop(ix,iy:integer):boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   NomLev:=StrToInt(Edit1.Text);
   if not (NomLev in [1..4]) then NomLev:=1;
   Map:=Levels[NomLev];
   ResetPole;
   DrawGrid1.Refresh;
end;
procedure TForm1.FormCreate(Sender: TObject);
begin
    NomLev:=1;
    Map:=Levels[NomLev];
    ToolButton1.Down:=true;
    ActBar:=ToolButton1.ImageIndex;
    ResetPole;
end;

procedure TForm1.DrawGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
const bar:array [0..7] of byte =(0,1,10,20,0,0,0,22);
begin
  if CanSelect and(ActBar>-1)and CheckBox1.Checked
  
    then Map[ARow,ACol]:=Bar[ActBar];
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  ActBar := TToolButton(Sender).ImageIndex;
end;

procedure TForm1.ResetPole;
Var i,j:integer;
begin
      For i:=0 to 11 do
       for  j:=0  to 19 do
       begin
            if Map[i,j] = 20 then
            Begin
                x:=i;
                y:=j;
                BarPole(j,i,Map[i,j]);
            end;
       end;

end;

procedure TForm1.ApplicationEvents1ShortCut(var Msg: TWMKey;
  var Handled: Boolean);
begin
     case Msg.CharCode of
       27:WindowState:=wsMinimized;
       37:BRight;
       38:BVerx;
       39:BLeft;
       40:BNuz;
     end;
end;

procedure TForm1.BLeft;
begin
     Napr:=4;
     if (Map[x,y]+Map[x,y+1]+Map[x,y+2]<40)or(Map[x,y+1]<5) then
     begin
        if Map[x,y+1]>9 then
        Begin
             Map[x,y+1]:=Map[x,y+1]-10;
             Map[x,y+2]:=Map[x,y+2]+10;
        end;
        Map[x,y]:=Map[x,y]-20;
        Map[x,y+1]:=Map[x,y+1]+20;

        BarPole((y+2),x,Map[x,y+2]);
        BarPole(y,x,Map[x,y]);

        inc(y);
     end;
    BarPole(y,x,Map[x,y]);
end;

procedure TForm1.BRight;
begin
     Napr:=2;
     if (Map[x,y]+Map[x,y-1]+Map[x,y-2]<40)or(Map[x,y-1]<5) then
     begin
        if Map[x,y-1]>9 then
        Begin
             Map[x,y-1]:=Map[x,y-1]-10;
             Map[x,y-2]:=Map[x,y-2]+10;
        end;
        Map[x,y]:=Map[x,y]-20;
        Map[x,y-1]:=Map[x,y-1]+20;
        BarPole((y-2),x,Map[x,y-2]);
        BarPole(y,x,Map[x,y]);

        dec(y);
     end;
    BarPole(y,x,Map[x,y]);
end;

procedure TForm1.BVerx;
begin
     Napr:=3;
     if (Map[x,y]+Map[x-1,y]+Map[x-2,y]<40)or(Map[x-1,y]<5) then
     begin
        if Map[x-1,y]>9 then
        Begin
             Map[x-1,y]:=Map[x-1,y]-10;
             Map[x-2,y]:=Map[x-2,y]+10;
        end;
        Map[x,y]:=Map[x,y]-20;
        Map[x-1,y]:=Map[x-1,y]+20;
        BarPole(y,(x-2),Map[x-2,y]);
        BarPole(y,x,Map[x,y]);

        dec(x);
     end;
     BarPole(y,x,Map[x,y]);
end;

procedure TForm1.BNuz;
begin
     Napr:=1;
     if (Map[x,y]+Map[x+1,y]+Map[x+2,y]<40)or(Map[x+1,y]<5) then
     begin
        if Map[x+1,y]>9 then
        Begin
             Map[x+1,y]:=Map[x+1,y]-10;
             Map[x+2,y]:=Map[x+2,y]+10;
        end;
        Map[x,y]:=Map[x,y]-20;
        Map[x+1,y]:=Map[x+1,y]+20;
        BarPole(y,(x+2),Map[x+2,y]);
        BarPole(y,x,Map[x,y]);
        inc(x);
     end;
     BarPole(y,x,Map[x,y]);
end;


function TForm1.Stop(ix, iy: integer): boolean;
var bool:Boolean;
begin
     Bool:=False;
     Byf[ix,iy]:=15;
     if Map[ix+1,iy]+Byf[ix+1,iy]<15 then Bool:=Stop(ix+1, iy) or Bool;
     if Map[ix,iy+1]+Byf[ix,iy+1]<15 then Bool:=Stop(ix, iy+1) or Bool;
     if Map[ix-1,iy]+Byf[ix-1,iy]<15 then Bool:=Stop(ix-1, iy) or Bool;
     if Map[ix,iy-1]+Byf[ix,iy-1]<15 then Bool:=Stop(ix, iy-1) or Bool;
     if Map[ix,iy]=1 then Bool:=true;
     if Map[ix,iy]=21 then Bool:=true;
     Stop:=Bool;
end;

procedure TForm1.BarPole(ACol, ARow: integer; typ: byte);
begin
     DrawGrid1.Row:=ARow;
     DrawGrid1.Col:=ACol;
end;

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
       ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,0);
       case Map[ARow,ACol] of
         1:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,1);
         10,11:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,2);
         22:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,7);
         20,21:
              case Napr of
                 1:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,3);
                 2:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,4);
                 3:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,5);
                 4:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,6);
               end;
        end;
       case Levels[NomLev][ARow,ACol] of
         1,11,21:ImageList1.Draw(DrawGrid1.Canvas,Rect.Left,Rect.Top,1);
       end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   DrawGrid1.Enabled:=CheckBox1.Checked
end;

end.
